<?php
//------------------------------------------------------------------------------
//--                                                                          --
//--    FILE NAME :  CsrfUtil.class.php                                       --
//--                                                                          --
//--        Designed by NeoJapan   2007-01-24   Ver. 1.00                     --
//--        Coded    by NeoJapan   2007-01-24   Ver. 1.00                     --
//--        Revised  by XXXXXXXXX  XXXX-XX-XX   Ver. X.00                     --
//--                                                                          --
//------------------------------------------------------------------------------
//--   (C)COPYRIGHT 2007 BY NeoJapan CORPORATION ALL RIGHTS RESERVED          --
//------------------------------------------------------------------------------

//------------------------------------------------------------------------------
// 󥯥롼
//------------------------------------------------------------------------------

//------------------------------------------------------------------------------
// 
//------------------------------------------------------------------------------
define('CSRF_DEF_KEY', 'cky');

//------------------------------------------------------------------------------
// 饹
//------------------------------------------------------------------------------
//------------------------------------------------------------------------------
//--    饹 CsrfUtil                                                     --
//--    Class  CsrfUtil                                                     --
//------------------------------------------------------------------------------
//--  MODIFIED        YYYY-MM-DD REV    - NOTES                               --
//--  NEOJAPAN        2007-01-24 1.00   - CREATE NEW                          --
//------------------------------------------------------------------------------
/**
 *  : CSRFѥ桼ƥƥ
 *        IDȯԵڤꥯȳǧ
 *  : - ѡХѿФưʲI/OԤǽ
 *          $_SESSION[I/O], $_GET[I], $_POST[I]
 *        - IDϽƼݤ˼ư
 *          IDϥåͭʸ¤Ȥޤ魯
 *        - IDΥѥ᡼̾ǥեȤϡcsrf
 *        - IDΥѥ᡼̾ʥå̾ˤѹ硢
 *          $GLOBALS['CSRF_KEY_FUNC']˼ؿ̾ꤹ
 *          ꤷؿΥ󥿡ե
 *          ʤ
 *          ͡ѥ᡼̾(string)
 *        - IDΥǥեȤϡȤꡢϥå(md5)ΤƬ10byte
 *        - IDåѹ硢
 *          $GLOBALS['CSRF_IDGEN_FUNC']˼ؿ̾ꤹ
 *          ꤷؿΥ󥿡ե
 *          ʤ
 *          ͡ID(string)
 */
class CsrfUtil
{
    //--------------------------------------------------------------------------
    //--    ؿ̾ CSRFID                                         --
    //--    Method bm_getID()                                               --
    //--------------------------------------------------------------------------
    //--  MODIFIED        YYYY-MM-DD REV    - NOTES                           --
    //--  NEOJAPAN        2007-01-24 1.00   - CREATE NEW                      --
    //--------------------------------------------------------------------------
    /**
     * CSRFID
     * ⤷ǼIDʤä硢IDȯԤݻ롣
     * 
     * @return string  CSRFID
     */
    function bm_getID()
    {
        // IDǼμ
        $key= CsrfUtil::bm_getKey();
        // ID
        $id = $_SESSION[$key];

        // ̤or
        if(!isset($id) || strlen($id) == 0){
            // IDȯ
            $newid  = CsrfUtil::rm_genetrteID();
            // IDݻ
            CsrfUtil::rm_setID($newid);

            $id = $newid;
        }

        return $id;
    }

    //--------------------------------------------------------------------------
    //--    ؿ̾ CSRFѥѥ᡼                                 --
    //--    Method bm_getKey()                                              --
    //--------------------------------------------------------------------------
    //--  MODIFIED        YYYY-MM-DD REV    - NOTES                           --
    //--  NEOJAPAN        2007-01-24 1.00   - CREATE NEW                      --
    //--------------------------------------------------------------------------
	/**
     * CSRFѥѥ᡼̾
     * $GLOBALS['CSRF_KEY_FUNC']˴ؿ̾ꤵƤ硢
     * δؿѤ
     * 
     * @return string  CSRFѥѥ᡼̾
     */
    function bm_getKey()
    {
        if(isset($GLOBALS['CSRF_KEY_FUNC']))
        {
            $func = $GLOBALS['CSRF_KEY_FUNC'];
            // ꥸʥ륭̾ȯԴؿƤ롩
            if(is_callable($func))
            {
                return call_user_func($func);
            }
        }
        return CSRF_DEF_KEY;
    }

    //--------------------------------------------------------------------------
    //--    ؿ̾ CSRFIDӽ                                         --
    //--    Method bm_isSafe()                                              --
    //--------------------------------------------------------------------------
    //--  MODIFIED        YYYY-MM-DD REV    - NOTES                           --
    //--  NEOJAPAN        2007-01-24 1.00   - CREATE NEW                      --
    //--------------------------------------------------------------------------
	/**
     * ѥ᡼ȥå󤫤CSRFID
     * ƱͤɤӤ롣
     * 
     * @return boolean  ʤξtrue顼ξfalse
     */
    function bm_isSafe()
    {
        // IDǼμ
        $key= CsrfUtil::bm_getKey();

        // ꥯȥ᥽åɤˤäƼѹ
        $req= $_SERVER['REQUEST_METHOD'] == 'POST' ? $_POST[$key] : $_GET[$key];
        $ses= $_SESSION[$key];
        // ӷ̤᤹
        return $ses === $req;
    }

    //--------------------------------------------------------------------------
    //--    ؿ̾ CSRFID                                         --
    //--    Method rm_genetrteID()                                          --
    //--------------------------------------------------------------------------
    //--  MODIFIED        YYYY-MM-DD REV    - NOTES                           --
    //--  NEOJAPAN        2007-01-24 1.00   - CREATE NEW                      --
    //--------------------------------------------------------------------------
    /**
     * CSRFID
     * $GLOBALS['CSRF_IDGEN_FUNC']˴ؿ̾ꤵƤ硢
     * δؿѤ
     *
     * @return string   CSRFID
     */
    function rm_genetrteID()
    {
        if(isset($GLOBALS['CSRF_IDGEN_FUNC']))
        {
            $func = $GLOBALS['CSRF_IDGEN_FUNC'];
            // ꥸʥIDؿƤ롩
            if(is_callable($func))
            {
                return call_user_func($func);
            }
        }
        $str = substr(md5(mt_rand()), 0, 10);
        return $str;
    }

    //--------------------------------------------------------------------------
    //--    ؿ̾ CSRFID                                         --
    //--    Method rm_setID()                                               --
    //--------------------------------------------------------------------------
    //--  MODIFIED        YYYY-MM-DD REV    - NOTES                           --
    //--  NEOJAPAN        2007-01-24 1.00   - CREATE NEW                      --
    //--------------------------------------------------------------------------
    /**
     * CSRFID򥻥åꤹ
     * @param   string  ꤹCSRFID
     */
    function rm_setID($id)
    {
        // IDǼμ
        $key= CsrfUtil::bm_getKey();
        // å¸
        $_SESSION[$key] = $id;
    }
}
?>